searchData={"items":[{"type":"module","title":"EarmarkParser","doc":"#","ref":"EarmarkParser.html"},{"type":"module","title":"API - EarmarkParser","doc":"##","ref":"EarmarkParser.html#module-api"},{"type":"module","title":"EarmarkParser.as_ast - EarmarkParser","doc":"This is the structure of the result of `as_ast`.\n\n    {:ok, ast, []}                   = EarmarkParser.as_ast(markdown)\n    {:ok, ast, deprecation_messages} = EarmarkParser.as_ast(markdown)\n    {:error, ast, error_messages}    = EarmarkParser.as_ast(markdown)\n\nFor examples see the functiondoc below.\n\n##","ref":"EarmarkParser.html#module-earmarkparser-as_ast"},{"type":"module","title":"Options - EarmarkParser","doc":"Options can be passed into `as_ast/2` according to the documentation of `EarmarkParser.Options`.\n\n    {status, ast, errors} = EarmarkParser.as_ast(markdown, options)","ref":"EarmarkParser.html#module-options"},{"type":"module","title":"Supports - EarmarkParser","doc":"Standard [Gruber markdown][gruber].\n\n[gruber]:","ref":"EarmarkParser.html#module-supports"},{"type":"module","title":"Extensions - EarmarkParser","doc":"#","ref":"EarmarkParser.html#module-extensions"},{"type":"module","title":"Links - EarmarkParser","doc":"##","ref":"EarmarkParser.html#module-links"},{"type":"module","title":"Links supported by default - EarmarkParser","doc":"###","ref":"EarmarkParser.html#module-links-supported-by-default"},{"type":"module","title":"Oneline HTML Link tags - EarmarkParser","doc":"iex(1)> EarmarkParser.as_ast(~s{ link })\n    {:ok, [{\"a\", [{\"href\", \"href\"}], [\"link\"], %{verbatim: true}}], []}\n\n###","ref":"EarmarkParser.html#module-oneline-html-link-tags"},{"type":"module","title":"Markdown links - EarmarkParser","doc":"New style ...\n\n    iex(2)> EarmarkParser.as_ast(~s{[title](destination)})\n    {:ok,  [{\"p\", [], [{\"a\", [{\"href\", \"destination\"}], [\"title\"], %{}}], %{}}], []}\n\nand old style\n\n    iex(3)> EarmarkParser.as_ast(\"[foo]: /url \\\"title\\\"\\n\\n[foo]\\n\")\n    {:ok, [{\"p\", [], [{\"a\", [{\"href\", \"/url\"}, {\"title\", \"title\"}], [\"foo\"], %{}}], %{}}], []}\n\n##","ref":"EarmarkParser.html#module-markdown-links"},{"type":"module","title":"Autolinks - EarmarkParser","doc":"iex(4)> EarmarkParser.as_ast(\" \")\n    {:ok, [{\"p\", [], [{\"a\", [{\"href\", \"https://elixir-lang.com\"}], [\"https://elixir-lang.com\"], %{}}], %{}}], []}\n\n##","ref":"EarmarkParser.html#module-autolinks"},{"type":"module","title":"Additional link parsing via options - EarmarkParser","doc":"##","ref":"EarmarkParser.html#module-additional-link-parsing-via-options"},{"type":"module","title":"Pure links - EarmarkParser","doc":"**N.B.** that the `pure_links` option is `true` by default\n\n    iex(5)> EarmarkParser.as_ast(\"https://github.com\")\n    {:ok, [{\"p\", [], [{\"a\", [{\"href\", \"https://github.com\"}], [\"https://github.com\"], %{}}], %{}}], []}\n\nBut can be deactivated\n\n    iex(6)> EarmarkParser.as_ast(\"https://github.com\", pure_links: false)\n    {:ok, [{\"p\", [], [\"https://github.com\"], %{}}], []}\n\n\n  ##","ref":"EarmarkParser.html#module-pure-links"},{"type":"module","title":"Wikilinks... - EarmarkParser","doc":"are disabled by default\n\n    iex(7)> EarmarkParser.as_ast(\"[[page]]\")\n    {:ok, [{\"p\", [], [\"[[page]]\"], %{}}], []}\n\n  and can be enabled\n\n    iex(8)> EarmarkParser.as_ast(\"[[page]]\", wikilinks: true)\n    {:ok, [{\"p\", [], [{\"a\", [{\"href\", \"page\"}], [\"page\"], %{wikilink: true}}], %{}}], []}\n\n\n#","ref":"EarmarkParser.html#module-wikilinks"},{"type":"module","title":"Sub and Sup HTML Elements - EarmarkParser","doc":"This feature is not enabled by default but can be enabled with the option `sub_sup: true`\n\nTherefore we will get\n\n    iex(9)> EarmarkParser.as_ast(\"H~2~O or a^n^ + b^n^ = c^n^\")\n    {:ok, [{\"p\", [], [\"H~2~O or a^n^ + b^n^ = c^n^\"], %{}}], []}\n\nBut by specifying `sub_sup: true`\n\n    iex(10)> EarmarkParser.as_ast(\"H~2~O or a^n^ + b^n^ = c^n^\", sub_sup: true)\n    {:ok, [{\"p\", [], [\"H\", {\"sub\", [], [\"2\"], %{}}, \"O or a\", {\"sup\", [], [\"n\"], %{}}, \" + b\", {\"sup\", [], [\"n\"], %{}}, \" = c\", {\"sup\", [], [\"n\"], %{}}], %{}}], []}\n\n#","ref":"EarmarkParser.html#module-sub-and-sup-html-elements"},{"type":"module","title":"Github Flavored Markdown - EarmarkParser","doc":"GFM is supported by default, however as GFM is a moving target and all GFM extension do not make sense in a general context, EarmarkParser does not support all of it, here is a list of what is supported:\n\n##","ref":"EarmarkParser.html#module-github-flavored-markdown"},{"type":"module","title":"Strike Through - EarmarkParser","doc":"iex(11)> EarmarkParser.as_ast(\"~~hello~~\")\n    {:ok, [{\"p\", [], [{\"del\", [], [\"hello\"], %{}}], %{}}], []}\n\n##","ref":"EarmarkParser.html#module-strike-through"},{"type":"module","title":"GFM Tables - EarmarkParser","doc":"Are not enabled by default\n\n    iex(12)> as_ast(\"a|b\\\\n-|-\\\\nc|d\\\\n\")\n    {:ok, [{\"p\", [], [\"a|b\\\\n-|-\\\\nc|d\\\\n\"], %{}}], []}\n\nBut can be enabled with `gfm_tables: true`\n\n    iex(13)> as_ast(\"a|b\\n-|-\\nc|d\\n\", gfm_tables: true)\n    {:ok,\n      [\n        {\n          \"table\",\n          [],\n          [\n            {\"thead\", [], [{\"tr\", [], [{\"th\", [{\"style\", \"text-align: left;\"}], [\"a\"], %{}}, {\"th\", [{\"style\", \"text-align: left;\"}], [\"b\"], %{}}], %{}}], %{}},\n            {\"tbody\", [], [{\"tr\", [], [{\"td\", [{\"style\", \"text-align: left;\"}], [\"c\"], %{}}, {\"td\", [{\"style\", \"text-align: left;\"}], [\"d\"], %{}}], %{}}], %{}}\n          ],\n          %{}\n        }\n      ],\n      []}\n\n##","ref":"EarmarkParser.html#module-gfm-tables"},{"type":"module","title":"Syntax Highlighting - EarmarkParser","doc":"All backquoted or fenced code blocks with a language string are rendered with the given\nlanguage as a _class_ attribute of the _code_ tag.\n\nFor example:\n\n    iex(14)> [\n    ...(14)>    \"```elixir\",\n    ...(14)>    \" @tag :hello\",\n    ...(14)>    \"```\"\n    ...(14)> ] |> as_ast()\n    {:ok, [{\"pre\", [], [{\"code\", [{\"class\", \"elixir\"}], [\" @tag :hello\"], %{}}], %{}}], []}\n\nwill be rendered as shown in the doctest above.\n\nIf you want to integrate with a syntax highlighter with different conventions you can add more classes by specifying prefixes that will be\nput before the language string.\n\nPrism.js for example needs a class `language-elixir`. In order to achieve that goal you can add `language-`\nas a `code_class_prefix` to `EarmarkParser.Options`.\n\nIn the following example we want more than one additional class, so we add more prefixes.\n\n    iex(15)> [\n    ...(15)>    \"```elixir\",\n    ...(15)>    \" @tag :hello\",\n    ...(15)>    \"```\"\n    ...(15)> ] |> as_ast(%EarmarkParser.Options{code_class_prefix: \"lang- language-\"})\n    {:ok, [{\"pre\", [], [{\"code\", [{\"class\", \"elixir lang-elixir language-elixir\"}], [\" @tag :hello\"], %{}}], %{}}], []}\n\n\n##","ref":"EarmarkParser.html#module-syntax-highlighting"},{"type":"module","title":"Footnotes - EarmarkParser","doc":"**N.B.** Footnotes are disabled by default, use `as_ast(..., footnotes: true)` to enable them\n\nFootnotes are now a **superset** of GFM Footnotes. This implies some changes\n\n  - Footnote definitions (`[^footnote_id]`) must come at the end of your document (_GFM_)\n  - Footnotes that are not referenced are not rendered anymore (_GFM_)\n  - Footnote definitions can contain any markup with the exception of footnote definitions\n\n        # iex(16)> markdown = [\n        # ...(16)> \"My reference[^to_footnote]\",\n        # ...(16)> \"\",\n        # ...(16)> \"[^1]: I am not rendered\",\n        # ...(16)> \"[^to_footnote]: Important information\"]\n        # ...(16)> {:ok, ast, []} = as_ast(markdown, footnotes: true)\n        # ...(16)> ast\n        # [\n        #   {\"p\", [], [\"My reference\",\n        #     {\"a\",\n        #     [{\"href\", \"#fn:to_footnote\"}, {\"id\", \"fnref:to_footnote\"}, {\"class\", \"footnote\"}, {\"title\", \"see footnote\"}],\n        #     [\"to_footnote\"], %{}}\n        #   ], %{}},\n        #   {\"div\",\n        #   [{\"class\", \"footnotes\"}],\n        #   [{\"hr\", [], [], %{}},\n        #     {\"ol\", [],\n        #     [{\"li\", [{\"id\", \"fn:to_footnote\"}],\n        #       [{\"a\", [{\"title\", \"return to article\"}, {\"class\", \"reversefootnote\"}, {\"href\", \"#fnref:to_footnote\"}], [\"&#x21A9;\"], %{}},\n        #         {\"p\", [], [\"Important information\"], %{}}], %{}}\n        #     ], %{}}], %{}}\n        # ]\n\n  For more complex examples of footnotes, please refer to\n  [these tests](https://github.com/RobertDober/earmark_parser/tree/master/test/acceptance/ast/footnotes/multiple_fn_test.exs)\n\n##","ref":"EarmarkParser.html#module-footnotes"},{"type":"module","title":"Breaks - EarmarkParser","doc":"Hard linebreaks are disabled by default\n\n        iex(17)> [\"* a\",\"  b\", \"c\"]\n        ...(17)> |> as_ast()\n        {:ok,\n          [{\"ul\", [], [{\"li\", [], [\"a\\nb\\nc\"], %{}}], %{}}],\n          []}\n\n    But can be enabled with `breaks: true`\n\n        iex(18)> [\"* a\",\"  b\", \"c\"]\n        ...(18)> |> as_ast(breaks: true)\n        {:ok, [{\"ul\", [], [{\"li\", [], [\"a\", {\"br\", [], [], %{}}, \"b\", {\"br\", [], [], %{}}, \"c\"], %{}}], %{}}], []}\n\n##","ref":"EarmarkParser.html#module-breaks"},{"type":"module","title":"Enabling **all** options that are disabled by default - EarmarkParser","doc":"Can be achieved with the `all: true` option\n\n        iex(19)> [\n        ...(19)> \"a^n^\",\n        ...(19)> \"b~2~\",\n        ...(19)> \"[[wikilink]]\"]\n        ...(19)> |> as_ast(all: true)\n        {:ok, [\n          {\"p\", [], [\"a\", {\"sup\", [], [\"n\"], %{}}, {\"br\", [], [], %{}}, \"b\", {\"sub\", [], [\"2\"], %{}}, {\"br\", [], [], %{}}, {\"a\", [{\"href\", \"wikilink\"}], [\"wikilink\"], %{wikilink: true}}], %{}}\n          ],\n          []}\n\n##","ref":"EarmarkParser.html#module-enabling-all-options-that-are-disabled-by-default"},{"type":"module","title":"Tables - EarmarkParser","doc":"Are supported as long as they are preceded by an empty line.\n\n    State | Abbrev | Capital\n    ----: | :----: | -------\n    Texas | TX     | Austin\n    Maine | ME     | Augusta\n\nTables may have leading and trailing vertical bars on each line\n\n    | State | Abbrev | Capital |\n    | ----: | :----: | ------- |\n    | Texas | TX     | Austin  |\n    | Maine | ME     | Augusta |\n\nTables need not have headers, in which case all column alignments\ndefault to left.\n\n    | Texas | TX     | Austin  |\n    | Maine | ME     | Augusta |\n\nCurrently we assume there are always spaces around interior vertical unless\nthere are exterior bars.\n\nHowever in order to be more GFM compatible the `gfm_tables: true` option\ncan be used to interpret only interior vertical bars as a table if a separation\nline is given, therefore\n\n     Language|Rating\n     --------|------\n     Elixir  | awesome\n\nis a table (if and only if `gfm_tables: true`) while\n\n     Language|Rating\n     Elixir  | awesome\n\nnever is.\n\n##","ref":"EarmarkParser.html#module-tables"},{"type":"module","title":"HTML Blocks - EarmarkParser","doc":"HTML is not parsed recursively or detected in all conditions right now, though GFM compliance\nis a goal.\n\nBut for now the following holds:\n\nA HTML Block defined by a tag starting a line and the same tag starting a different line is parsed\nas one HTML AST node, marked with %{verbatim: true}\n\nE.g.\n\n    iex(20)> lines = [ \"  \", \"some  \", \" more text\" ]\n    ...(20)> EarmarkParser.as_ast(lines)\n    {:ok, [{\"div\", [], [\" \", \"some  \"], %{verbatim: true}}, \"more text\"], []}\n\nAnd a line starting with an opening tag and ending with the corresponding closing tag is parsed in similar\nfashion\n\n    iex(21)> EarmarkParser.as_ast([\" spaniel \"])\n    {:ok, [{\"span\", [{\"class\", \"superspan\"}], [\"spaniel\"], %{verbatim: true}}], []}\n\nWhat is HTML?\n\nWe differ from strict GFM by allowing **all** tags not only HTML5 tags this holds for one liners....\n\n    iex(22)> {:ok, ast, []} = EarmarkParser.as_ast([\" \", \" better \"])\n    ...(22)> ast\n    [\n      {\"stupid\", [], [], %{verbatim: true}},\n      {\"not\", [], [\"better\"], %{verbatim: true}}]\n\nand for multi line blocks\n\n    iex(23)> {:ok, ast, []} = EarmarkParser.as_ast([ \" \", \"world\", \" \"])\n    ...(23)> ast\n    [{\"hello\", [], [\"world\"], %{verbatim: true}}]\n\n##","ref":"EarmarkParser.html#module-html-blocks"},{"type":"module","title":"HTML Comments - EarmarkParser","doc":"Are recognized if they start a line (after ws and are parsed until the next `-->` is found\nall text after the next '-->' is ignored\n\nE.g.\n\n    iex(24)> EarmarkParser.as_ast(\"   text -->\\nafter\")\n    {:ok, [{:comment, [], [\" Comment\", \"comment line\", \"comment \"], %{comment: true}}, {\"p\", [], [\"after\"], %{}}], []}\n\n\n##","ref":"EarmarkParser.html#module-html-comments"},{"type":"module","title":"Lists - EarmarkParser","doc":"Lists are pretty much GFM compliant, but some behaviors concerning the interpreation of the markdown inside a List Item's first\nparagraph seem not worth to be interpreted, examples are blockquote in a tight [list item](ttps://babelmark.github.io/?text=*+aa%0A++%3E+Second)\nwhich we can only have in a [loose one](https://babelmark.github.io/?text=*+aa%0A++%0A++%3E+Second)\n\nOr a headline in a [tight list item](https://babelmark.github.io/?text=*+bb%0A++%23+Headline) which, again is only available in the\n[loose version](https://babelmark.github.io/?text=*+bb%0A%0A++%23+Headline) in EarmarkParser.\n\nfurthermore [this example](https://babelmark.github.io/?text=*+aa%0A++%60%60%60%0ASecond%0A++%60%60%60) demonstrates how weird\nand definitely not useful GFM's own interpretation can get.\n\nTherefore we stick to a more predictable approach.\n\n      iex(25)> markdown = [\n      ...(25)> \"* aa\",\n      ...(25)> \"  ```\",\n      ...(25)> \"Second\",\n      ...(25)> \"  ```\" ]\n      ...(25)> as_ast(markdown)\n      {:ok, [{\"ul\", [], [{\"li\", [], [\"aa\", {\"pre\", [], [{\"code\", [], [\"Second\"], %{}}], %{}}], %{}}], %{}}], []}\n\nAlso we do support the immediate style of block content inside lists\n\n      iex(26)> as_ast(\"* > Nota Bene!\")\n      {:ok, [{\"ul\", [], [{\"li\", [], [{\"blockquote\", [], [{\"p\", [], [\"Nota Bene!\"], %{}}], %{}}], %{}}], %{}}], []}\n\nor\n\n      iex(27)> as_ast(\"1. # Breaking...\")\n      {:ok, [{\"ol\", [], [{\"li\", [], [{\"h1\", [], [\"Breaking...\"], %{}}], %{}}], %{}}], []}\n\n\n#","ref":"EarmarkParser.html#module-lists"},{"type":"module","title":"Adding Attributes with the IAL extension - EarmarkParser","doc":"##","ref":"EarmarkParser.html#module-adding-attributes-with-the-ial-extension"},{"type":"module","title":"To block elements - EarmarkParser","doc":"HTML attributes can be added to any block-level element. We use\nthe Kramdown syntax: add the line `{:` _attrs_ `}` following the block.\n\n    iex(28)> markdown = [\"# Headline\", \"{:.from-next-line}\"]\n    ...(28)> as_ast(markdown)\n    {:ok, [{\"h1\", [{\"class\", \"from-next-line\"}], [\"Headline\"], %{}}], []}\n\nHeaders can also have the IAL string at the end of the line\n\n    iex(29)> markdown = [\"# Headline{:.from-same-line}\"]\n    ...(29)> as_ast(markdown)\n    {:ok, [{\"h1\", [{\"class\", \"from-same-line\"}], [\"Headline\"], %{}}], []}\n\nA special use case is headers inside blockquotes which allow for some nifty styling in `ex_doc`*\nsee [this PR](https://github.com/elixir-lang/ex_doc/pull/1400) if you are interested in the technical\ndetails\n\n    iex(30)> markdown = [\"> # Headline{:.warning}\"]\n    ...(30)> as_ast(markdown)\n    {:ok, [{\"blockquote\", [], [{\"h1\", [{\"class\", \"warning\"}], [\"Headline\"], %{}}], %{}}], []}\n\nThis also works for headers inside lists\n\n    iex(31)> markdown = [\"- # Headline{:.warning}\"]\n    ...(31)> as_ast(markdown)\n    {:ok, [{\"ul\", [], [{\"li\", [], [{\"h1\", [{\"class\", \"warning\"}], [\"Headline\"], %{}}], %{}}], %{}}], []}\n\nIt still works for inline code, as it did before\n\n    iex(32)> markdown = \"`Enum.map`{:lang=elixir}\"\n    ...(32)> as_ast(markdown)\n    {:ok, [{\"p\", [], [{\"code\", [{\"class\", \"inline\"}, {\"lang\", \"elixir\"}], [\"Enum.map\"], %{}}], %{}}], []}\n\n\n_attrs_ can be one or more of:\n\n  * `.className`\n  * `#id`\n  * name=value, name=\"value\", or name='value'\n\nFor example:\n\n    # Warning\n    {: .red}\n\n    Do not turn off the engine\n    if you are at altitude.\n    {: .boxed #warning spellcheck=\"true\"}\n\n##","ref":"EarmarkParser.html#module-to-block-elements"},{"type":"module","title":"To links or images - EarmarkParser","doc":"It is possible to add IAL attributes to generated links or images in the following\nformat.\n\n    iex(33)> markdown = \"[link](url) {: .classy}\"\n    ...(33)> EarmarkParser.as_ast(markdown)\n    { :ok, [{\"p\", [], [{\"a\", [{\"class\", \"classy\"}, {\"href\", \"url\"}], [\"link\"], %{}}], %{}}], []}\n\nFor both cases, malformed attributes are ignored and warnings are issued.\n\n    iex(34)> [ \"Some text\", \"{:hello}\" ] |> Enum.join(\"\\n\") |> EarmarkParser.as_ast()\n    {:error, [{\"p\", [], [\"Some text\"], %{}}], [{:warning, 2,\"Illegal attributes [\\\"hello\\\"] ignored in IAL\"}]}\n\nIt is possible to escape the IAL in both forms if necessary\n\n    iex(35)> markdown = \"[link](url)\\\\{: .classy}\"\n    ...(35)> EarmarkParser.as_ast(markdown)\n    {:ok, [{\"p\", [], [{\"a\", [{\"href\", \"url\"}], [\"link\"], %{}}, \"{: .classy}\"], %{}}], []}\n\nThis of course is not necessary in code blocks or text lines\ncontaining an IAL-like string, as in the following example\n\n    iex(36)> markdown = \"hello {:world}\"\n    ...(36)> EarmarkParser.as_ast(markdown)\n    {:ok, [{\"p\", [], [\"hello {:world}\"], %{}}], []}","ref":"EarmarkParser.html#module-to-links-or-images"},{"type":"module","title":"Limitations - EarmarkParser","doc":"* Block-level HTML is correctly handled only if each HTML\n    tag appears on its own line. So\n\n         \n         \n        hello\n         \n         \n\n    will work. However. the following won't\n\n         \n        hello \n\n  * John Gruber's tests contain an ambiguity when it comes to\n    lines that might be the start of a list inside paragraphs.\n\n    One test says that\n\n        This is the text\n        * of a paragraph\n        that I wrote\n\n    is a single paragraph. The \"*\" is not significant. However, another\n    test has\n\n        *   A list item\n            * an another\n\n    and expects this to be a nested list. But, in reality, the second could just\n    be the continuation of a paragraph.\n\n    I've chosen always to use the second interpretation—a line that looks like\n    a list item will always be a list item.\n\n  * Rendering of block and inline elements.\n\n    Block or void HTML elements that are at the absolute beginning of a line end\n    the preceding paragraph.\n\n    Thusly\n\n        mypara\n         \n\n    Becomes\n\n         mypara \n         \n\n    While\n\n        mypara\n          \n\n    will be transformed into\n\n         mypara","ref":"EarmarkParser.html#module-limitations"},{"type":"module","title":"Annotations - EarmarkParser","doc":"**N.B.** this is an experimental feature from v1.4.16-pre on and might change or be removed again\n\nThe idea is that each markdown line can be annotated, as such annotations change the semantics of Markdown\nthey have to be enabled with the `annotations` option.\n\nIf the `annotations` option is set to a string (only one string is supported right now, but a list might\nbe implemented later on, hence the name), the last occurrence of that string in a line and all text following\nit will be added to the line as an annotation.\n\nDepending on how that line will eventually be parsed, this annotation will be added to the meta map (the 4th element\nin an AST quadruple) with the key `:annotation`\n\nIn the current version the annotation will only be applied to verbatim HTML tags and paragraphs\n\nLet us show some examples now:\n\n#","ref":"EarmarkParser.html#module-annotations"},{"type":"module","title":"Annotated Paragraphs - EarmarkParser","doc":"iex(37)> as_ast(\"hello %> annotated\", annotations: \"%>\")\n    {:ok, [{\"p\", [], [\"hello \"], %{annotation: \"%> annotated\"}}], []}\n\nIf we annotate more than one line in a para the first annotation takes precedence\n\n    iex(38)> as_ast(\"hello %> annotated\\nworld %> discarded\", annotations: \"%>\")\n    {:ok, [{\"p\", [], [\"hello \\nworld \"], %{annotation: \"%> annotated\"}}], []}\n\n#","ref":"EarmarkParser.html#module-annotated-paragraphs"},{"type":"module","title":"Annotated HTML elements - EarmarkParser","doc":"In one line\n\n    iex(39)> as_ast(\" One Line  // a span\", annotations: \"//\")\n    {:ok, [{\"span\", [], [\"One Line\"], %{annotation: \"// a span\", verbatim: true}}], []}\n\nor block elements\n\n    iex(40)> [\n    ...(40)> \"  : annotation\",\n    ...(40)> \"   text \",\n    ...(40)> \"  : discarded\"\n    ...(40)> ] |> as_ast(annotations: \" : \")\n    {:ok, [{\"div\", [], [\"   text \"], %{annotation: \" : annotation\", verbatim: true}}], []}\n\n#","ref":"EarmarkParser.html#module-annotated-html-elements"},{"type":"module","title":"Commenting your Markdown - EarmarkParser","doc":"Although many markdown elements do not support annotations yet, they can be used to comment your markdown, w/o cluttering\nthe generated AST with comments\n\n    iex(41)> [\n    ...(41)> \"# Headline --> first line\",\n    ...(41)> \"- item1 --> a list item\",\n    ...(41)> \"- item2 --> another list item\",\n    ...(41)> \"\",\n    ...(41)> \"  --> do not go there\"\n    ...(41)> ] |> as_ast(annotations: \"-->\")\n    {:ok, [\n      {\"h1\", [], [\"Headline\"], %{}},\n      {\"ul\", [], [{\"li\", [], [\"item1 \"], %{}}, {\"li\", [], [\"item2 \"], %{}}], %{}},\n      {\"p\", [], [{\"a\", [{\"href\", \"http://somewhere/to/go\"}], [\"http://somewhere/to/go\"], %{}}, \" \"], %{annotation: \"--> do not go there\"}}\n      ], []\n     }","ref":"EarmarkParser.html#module-commenting-your-markdown"},{"type":"function","title":"EarmarkParser.as_ast/2","doc":"iex(42)> markdown = \"My `code` is **best**\"\n    ...(42)> {:ok, ast, []} = EarmarkParser.as_ast(markdown)\n    ...(42)> ast\n    [{\"p\", [], [\"My \", {\"code\", [{\"class\", \"inline\"}], [\"code\"], %{}}, \" is \", {\"strong\", [], [\"best\"], %{}}], %{}}]\n\n\n\n    iex(43)> markdown = \"```elixir\\nIO.puts 42\\n```\"\n    ...(43)> {:ok, ast, []} = EarmarkParser.as_ast(markdown, code_class_prefix: \"lang-\")\n    ...(43)> ast\n    [{\"pre\", [], [{\"code\", [{\"class\", \"elixir lang-elixir\"}], [\"IO.puts 42\"], %{}}], %{}}]\n\n**Rationale**:\n\nThe AST is exposed in the spirit of [Floki's](https://hex.pm/packages/floki).","ref":"EarmarkParser.html#as_ast/2"},{"type":"function","title":"EarmarkParser.version/0","doc":"Accesses current hex version of the `EarmarkParser` application. Convenience for\n  `iex` usage.","ref":"EarmarkParser.html#version/0"},{"type":"type","title":"EarmarkParser.ast/0","doc":"","ref":"EarmarkParser.html#t:ast/0"},{"type":"type","title":"EarmarkParser.ast_attribute/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute/0"},{"type":"type","title":"EarmarkParser.ast_attribute_name/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute_name/0"},{"type":"type","title":"EarmarkParser.ast_attribute_value/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute_value/0"},{"type":"type","title":"EarmarkParser.ast_attributes/0","doc":"","ref":"EarmarkParser.html#t:ast_attributes/0"},{"type":"type","title":"EarmarkParser.ast_meta/0","doc":"","ref":"EarmarkParser.html#t:ast_meta/0"},{"type":"type","title":"EarmarkParser.ast_node/0","doc":"","ref":"EarmarkParser.html#t:ast_node/0"},{"type":"type","title":"EarmarkParser.ast_tag/0","doc":"","ref":"EarmarkParser.html#t:ast_tag/0"},{"type":"type","title":"EarmarkParser.ast_tuple/0","doc":"","ref":"EarmarkParser.html#t:ast_tuple/0"},{"type":"type","title":"EarmarkParser.error/0","doc":"","ref":"EarmarkParser.html#t:error/0"},{"type":"type","title":"EarmarkParser.errors/0","doc":"","ref":"EarmarkParser.html#t:errors/0"},{"type":"type","title":"EarmarkParser.t/0","doc":"","ref":"EarmarkParser.html#t:t/0"},{"type":"module","title":"EarmarkParser.Enum.Ext","doc":"Some extensions of Enum functions","ref":"EarmarkParser.Enum.Ext.html"},{"type":"function","title":"EarmarkParser.Enum.Ext.reduce_with_end/3","doc":"`reduce_with_end` is like `Enum.reduce` for lists, but the reducer function is called for\neach element of the list with the tuple `{:element, element}` and the accumulator and once\nmore at the end with `:end` and the accumulator\n\n    iex(1)> reducer =\n    ...(1)>   fn {:element, nil}, {partial, result} -> {[], [Enum.sum(partial)|result]}\n    ...(1)>      {:element, val}, {partial, result} -> {[val|partial], result}\n    ...(1)>      :end,            {partial, result} -> [Enum.sum(partial)|result] |> Enum.reverse\n    ...(1)>   end\n    ...(1)> [1, 2, nil, 4, 1, 0, nil, 3, 2, 2]\n    ...(1)> |> reduce_with_end({[], []}, reducer)\n    [3, 5, 7]\n\n**N.B.** that in the treatment of `:end` we can change the shape of the accumulator w/o any\npenalty concerning the complexity of the reducer function","ref":"EarmarkParser.Enum.Ext.html#reduce_with_end/3"},{"type":"function","title":"EarmarkParser.Enum.Ext.reverse_map_reduce/3","doc":"Like map_reduce but reversing the list\n\n    iex(2)> replace_nil_and_count = fn ele, acc ->\n    ...(2)>   if ele, do: {ele, acc}, else: {\"\", acc + 1}\n    ...(2)> end\n    ...(2)> [\"y\", nil, \"u\", nil, nil, \"a\", nil] |> reverse_map_reduce(0, replace_nil_and_count)\n    { [\"\", \"a\", \"\", \"\", \"u\", \"\", \"y\"], 4 }","ref":"EarmarkParser.Enum.Ext.html#reverse_map_reduce/3"},{"type":"module","title":"EarmarkParser.Options","doc":"","ref":"EarmarkParser.Options.html"},{"type":"function","title":"EarmarkParser.Options.normalize/1","doc":"Use normalize before passing it into any API function\n\n      iex(1)> options = normalize(annotations: \"%%\")\n      ...(1)> options.annotations\n      ~r{\\A(.*)(%%.*)}","ref":"EarmarkParser.Options.html#normalize/1"},{"type":"type","title":"EarmarkParser.Options.t/0","doc":"","ref":"EarmarkParser.Options.html#t:t/0"}],"content_type":"text/markdown"}